
# [v3.1.0] - 2024-07-17 

## BACKEND

### Added

- intelli-service: Add widget names migration.
- intelli-service: Add portal job start.
- intelli-service: Add alarm counter.
- intelli-service: Add annotation time normalization.
- genstx: Add newest library.
- genstx: New model applications and delimiter implementation (#48282).
- genstx: New package server extend server with warning and log emitter (#49964).

### Changed

- intelli-service: Change parentNode to yAxis.
- intelli-service: Change portal api endpoint name.

### Fixed

- api-broker: Api-Broker sparql client is fixed - missed accept header has been added (#49626).
- DMS: Fix short get command (#50078).
- DMS: Fix copy node recursion (#49540).
- Setup: Fix;; uninstall/install of vcredist 2019 (#49124).
- intelli-service: Fix alarm handler.
- Designer: Image Files are structured in rest-db (#49969).
- Designer: Destination folder for project images is fixed (#49954).

### Other

- apigateway: Implement access-token login through auto login.
- apigateway: Always remove allow origin in proxy stack because we handle it in single reverse proxy.
- apigateway: Refactor settings and run server http and https per default.
- mqttdriver: Optimize log if DMS sends errors in set (#49205).

## FRONTEND

### Added

- vue-ng-lib: Add i18n translation to md editor.
- vue-ng-lib: Accepted files extensions are added (#47724).
- bai: Add multi row deletion.

### Changed

- vue-ng-lib: Changed readonly attribute name.
- vue-ng-lib: Prefix for export can be empty (#49478).

### Fixed

- vue-ng-lib: Refactor adds NgButton if only one entry exists.
- vue-ng-lib: Diff and time are added to "TRD DP add" dialog (#48787).
- vue-ng-lib: Add NgDMSAlarmColorTable Component.
- vue-ng-lib: Prepare info prop for components and add css style to markdown (#49316).
- vue-ng-lib: Fix key on select server (#41179).
- vue-ng-lib: Fix inject serviceUuids from parent to childs (#41179).
- vue-ng-lib: Fix of design dms node chart component (#49671).
- vue-ng-lib: Fix of NgDMSNodeChart Component (#49671).
- vue-ng-lib: Fix of NgDMSAlarmInstructions sizes (#49627)
- vue-ng-lib: Fix missing set interpolation in dms chart (#49585).
- vue-ng-lib: Fix missing endpoints in EndpointRepository (#49577).
- vue-ng-lib: Web Component rendering has been fixed.
- vue-ng-lib: Fix rendering Asnyc-Component import in NgUI (#49333).
- vue-ng-lib: Fix update model value in splitter (#49328).
- vue-ng-lib: Fix unsetted data in useForm for NgControls (#49038).
- vue-ng-lib: Fix maximum stack call and optimize key variables (#49038).
- vue-ng-lib: Fix undefined focus emitter.
- vue-ng-lib: Fix copy paste widgets in template panel (#49313).
- Designer: Reinitialisation of the dialog objects is fixed (#49965).
- bai: Fixed config model folder deletion on page deletion if no configModel exists.

### Other

- vue-ng-lib: Implement secure communication between NGs (#41179).
- vue-ng-lib: Remove save config in dms-chart because this is not needed (#49585).
- vue-ng-lib: AlarmInstructions component has been refactored (#47724).
- vue-ng-lib: New component for assignment of the alarms texts is implemented (#47724).
- vue-ng-lib: Debounce splitter update (#49328).
- vue-ng-lib: Emit selected events (#49317).
- vue-ng-lib: Double click emit on group item (#49313).
- vue-ng-lib: Copy paste template panel tabs (#49315).

## CONFIGURATION

### Added

- rest-data: Add applications (#48282).
- rest-data: Add alarm format to alarm page.

### Fixed

- rest-data: Fix chart widget by setting the correct processManagerUuid in chart nodes.
- rest-data: fix wrong labels (#48068).
- rest-data: Fix of change image web component (#47275).
- rest-data: Fix call onInit in mounted hook, call it in onSubscribed callback (#49585).
- rest-data: Fix NgSplitter in modules (#49328).

### Other

- rest-data: Implement secure service communication (#41179).
- rest-data: dms.chart component has been updated (#49671).
- rest-data: Web components are adjusted (#47275).
- rest-data: Optimize dms.chart Web-Component for designer (#49581).
- rest-data: Translations are adjusted (#48787).
- rest-data: Lang for template panel info (#49316).


# [v3.0.1] - 2024-06-10

## General

- Initial stable setup

