// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    props: [
      'object',
      'design',
      'panel',
    ],

    config: {
      startPanel: 'settings',
      panels: [
        {
          header: 'settings',
          name: 'settings',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                showReset: false,
                schema: [
                  {
                    type: 'dms-path',
                    label: 'path',
                    default: {},
                    scope: 'setValueData.link',
                    'call.enableTypes': `
                      const types = []
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return types
                      }
                      switch(ctx.data.setValueData.attrs.type) {
                        case 'text':
                        case 'password':
                        case 'email':
                        case 'color':
                        case 'phone':
                          types.push('string')
                          break;
                        case 'number':
                          types.push('int', 'int8', 'int16', 'int32', 'double', 'uint', 'uint8', 'uint16', 'uint32')
                          break;
                        case 'toggle':
                          types.push('bool')
                          break;
                      }
                      return types
                    `
                  },
                  {
                    type: 'text',
                    label: 'label',
                    default: 'value',
                    scope: 'setValueData.attrs.label',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.isLabelLink === true
                    `,
                  },
                  {
                    type: 'dms-path',
                    label: 'labelPath',
                    default: {},
                    scope: 'setValueData.attrs.labelLink',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.isLabelLink === false
                    `,
                  },
                  {
                    type: 'checkbox',
                    scope: 'setValueData.attrs.isLabelLink',
                    label: 'isLabelLink',
                    default: false,
                    col: 'col-12',
                  },
                  {
                    type: 'text',
                    label: 'submitLabel',
                    default: 'setValue',
                    scope: 'setValueData.attrs.submitLabel',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ['constant'].includes(ctx.data.setValueData.attrs.type) || ctx.data.setValueData.attrs.isSubmitLabelLink === true
                    `,
                  },
                  {
                    type: 'dms-path',
                    label: 'submitLabelPath',
                    default: {},
                    scope: 'setValueData.attrs.submitLabelLink',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ['constant'].includes(ctx.data.setValueData.attrs.type) || ctx.data.setValueData.attrs.isSubmitLabelLink === false
                    `,
                  },
                  {
                    type: 'checkbox',
                    scope: 'setValueData.attrs.isSubmitLabelLink',
                    label: 'isSubmitLabelLink',
                    default: false,
                    col: 'col-12',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ['constant'].includes(ctx.data.setValueData.attrs.type)
                    `,
                  },
                  {
                    type: 'select',
                    label: 'type',
                    default: '',
                    scope: 'setValueData.attrs.type',
                    options: [
                      { label: 'auto', value: '' },
                      { label: 'text', value: 'text' },
                      { label: 'email', value: 'email' },
                      { label: 'password', value: 'password' },
                      { label: 'color', value: 'color' },
                      { label: 'time', value: 'time' },
                      { label: 'date', value: 'date' },
                      { label: 'date-time', value: 'date-time' },
                      { label: 'number', value: 'number' },
                      { label: 'toggle', value: 'toggle' },
                      { label: 'select', value: 'select' },
                      { label: 'constant', value: 'constant' },
                    ]
                  },
                  {
                    type: 'select',
                    scope: 'setValueData.attrs.constantType',
                    label: 'constantType',
                    default: undefined,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return !['toggle', 'constant'].includes(ctx.data.setValueData.attrs.type)
                    `,
                    col: 'col-12',
                    options: [
                      { label: 'none', value: '' },
                      { label: 'string', value: 'text' },
                      { label: 'number', value: 'number' },
                      { label: 'boolean', value: 'checkbox' },
                    ]
                  },
                  {
                    type: 'select',
                    scope: 'setValueData.attrs.constantSetType',
                    label: 'constantSetType',
                    default: 'set',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return !['constant'].includes(ctx.data.setValueData.attrs.type) || !['checkbox'].includes(ctx.data.setValueData.attrs.constantType)
                    `,
                    col: 'col-12',
                    options: [
                      { label: 'set', value: 'set' },
                      { label: 'reset', value: 'reset' },
                      { label: 'toggle', value: 'toggle' },
                      { label: 'impulse', value: 'impulse' },
                    ]
                  },
                  {
                    type: 'checkbox',
                    scope: 'setValueData.attrs.isConstantLink',
                    label: 'isConstantLink',
                    default: false,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'constant' || ctx.data.setValueData.attrs.constantType === 'checkbox'
                    `,
                    col: 'col-12',
                  },
                  {
                    scope: 'setValueData.attrs.constantClickValue',
                    label: 'constantValue',
                    default: undefined,
                    'call.type': `return ctx.data.setValueData.attrs.constantType`,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'constant' || ctx.data.setValueData.attrs.isConstantLink === true || ctx.data.setValueData.attrs.constantType === 'checkbox'
                    `,
                    col: 'col-12',
                  },
                  {
                    type: 'dms-path',
                    label: 'constantPath',
                    default: {},
                    scope: 'setValueData.attrs.constantClickLink',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'constant' || ctx.data.setValueData.attrs.isConstantLink === false
                    `,
                  },
                  {
                    scope: 'setValueData.attrs.constantFalseValue',
                    label: 'constantFalseValue',
                    default: false,
                    'call.type': `return ctx.data.setValueData.attrs.constantType`,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'toggle'
                    `,
                    col: 'col-6',
                  },
                  {
                    scope: 'setValueData.attrs.constantTrueValue',
                    label: 'constantTrueValue',
                    default: true,
                    'call.type': `return ctx.data.setValueData.attrs.constantType`,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'toggle'
                    `,
                    col: 'col-6',
                  },
                  {
                    type: 'number',
                    scope: 'setValueData.attrs.min',
                    label: 'min',
                    default: undefined,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'number'
                    `,
                    col: 'col-6',
                  },
                  {
                    type: 'number',
                    scope: 'setValueData.attrs.max',
                    label: 'max',
                    default: undefined,
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'number'
                    `,
                    col: 'col-6',
                  },
                  {
                    type: 'key-value',
                    scope: 'setValueData.attrs.options',
                    label: 'options',
                    keyIdent: 'label',
                    default: [],
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'select'
                    `,
                    schema: [
                      { name: 'label', i18nLabel: 'label', field: 'label' },
                      { name: 'value', i18nLabel: 'value', field: 'value'  },
                    ],
                    col: 'col-12',
                  },
                  {
                    type: 'text',
                    scope: 'setValueData.attrs.format',
                    label: 'format',
                    default: '',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'date-time' && ctx.data.setValueData.attrs.type !== 'date' && ctx.data.setValueData.attrs.type !== 'time'
                    `,
                    'call.hint': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return ''
                      }
                      switch (ctx.data.setValueData.attrs.type) {
                        case 'date-time':
                          return 'YYYY-MM-DD HH:mmZ, X (unix)'
                        case 'date':
                          return 'YYYY-MM-DD'
                        case 'time':
                          return 'X (unix), HH:mm:ss, s, ms'
                      }
                      return ''
                    `,
                    col: 'col-6',
                  },
                  {
                    type: 'text',
                    scope: 'setValueData.attrs.mask',
                    label: 'mask',
                    default: '',
                    'call.hidden': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return true
                      }
                      return ctx.data.setValueData.attrs.type !== 'date-time' && ctx.data.setValueData.attrs.type !== 'date' && ctx.data.setValueData.attrs.type !== 'time'
                    `,
                    'call.hint': `
                      if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                        return ''
                      }
                      switch (ctx.data.setValueData.attrs.type) {
                        case 'date-time':
                          return 'YYYY-MM-DD HH:mmZ, X (unix)'
                        case 'date':
                          return 'YYYY-MM-DD'
                        case 'time':
                          return 'X (unix), HH:mm:ss, s, ms'
                      }
                      return ''
                    `,
                    col: 'col-6',
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'writePermissions',
                    hint: 'writePermissionsDescription',
                    scope: 'rights.write',
                    col: 'col-12',
                  },
                ]
              },
            }
          ]
        },
      ]
    },
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        computedObject: null,
        linked: false,
        eventValue: null,
		ident: '',
        type: '',
        setType: '',
        constantLinkObject: null,
        labelLinkObject: null,
        submitLabelLinkObject: null,
        constantValue: null,
        hold: false,
        holdClick: false,
      }
    },
    
    watch: {
      'object.customData': {
        handler() {
          this.panel.setPermissions(this.object.customData.rights, this.object.customData.setValueData)
        },
        deep: true,
      },
    },
    
    created() {
      this.linked = false;
      // do we handle impulse constant?
      this.hold = this.object.customData.setValueData.attrs.constantSetType === 'impulse' && this.object.customData.setValueData.attrs.constantType === 'checkbox' 
                  && this.object.customData.setValueData.attrs.type === 'constant'
      if (this.object && this.object.customData && this.object.customData.setValueData) {
        if (this.object.customData.setValueData.link && this.object.customData.setValueData.link.processUuid) {
          this.computedObject = this.panel.createComputedObject(this.object.customData.setValueData.link)
		  this.ident = `${this.object.customData.setValueData.link.processUuid}:${this.object.customData.setValueData.link.path}`
          // subscribe computed object
          this.panel.on(this.computedObject, '', this.onEvent.bind(this))
          this.linked = true;
          if (this.object.customData.setValueData.attrs.isConstantLink) {
            const constLink = this.object.customData.setValueData.attrs.constantClickLink
            this.constantLinkObject = this.panel.createComputedObject(constLink)
            this.constantLinkObject.ident = `${constLink.processUuid}:${constLink.path}`
            this.panel.on(this.constantLinkObject, '', this.onEvent.bind(this))
          } else {
            this.constantValue = this.object.customData.setValueData.attrs.constantClickValue;
          }
          if (this.object.customData.setValueData.attrs.isLabelLink) {
            const labelLink = this.object.customData.setValueData.attrs.labelLink
            this.labelLinkObject = this.panel.createComputedObject(labelLink)
            this.labelLinkObject.ident = `${labelLink.processUuid}:${labelLink.path}`
            this.panel.on(this.labelLinkObject, '', this.onEvent.bind(this))
          }
          if (this.object.customData.setValueData.attrs.isSubmitLabelLink) {
            const submitLabelLink = this.object.customData.setValueData.attrs.submitLabelLink
            this.submitLabelLinkObject = this.panel.createComputedObject(submitLabelLink)
            this.submitLabelLinkObject.ident = `${submitLabelLink.processUuid}:${submitLabelLink.path}`
            this.panel.on(this.submitLabelLinkObject, '', this.onEvent.bind(this))
          }
        }
      }

      if (!this.object.customData.setValueData) {
        this.object.customData.setValueData = {}
      }

      if (!this.object.customData.setValueData.attrs) {
        this.object.customData.setValueData.attrs = {}
      }

      this.type = this.object.customData.setValueData.attrs.type || ''
      this.setType = this.object.customData.setValueData.attrs.constantSetType || ''
      this.panel.setPermissions(this.object.customData.rights, this.object.customData.setValueData)
    },

    // Listen on unmounted event...
    unmounted() {
      if (this.computedObject) {
        this.panel.off(this.computedObject, '', this.onEvent.bind(this))
      }

      if (this.constantLinkObject) {
        this.panel.off(this.constantLinkObject, '', this.onEvent.bind(this))
      }

      if (this.labelLinkObject) {
        this.panel.off(this.labelLinkObject, '', this.onEvent.bind(this))
      }

      if (this.submitLabelLinkObject) {
        this.panel.off(this.submitLabelLinkObject, '', this.onEvent.bind(this))
      }
    },

    methods: {
      onPublish(newValue) {
        const path = this.computedObject.getPath();
        this.panel.emit(this.computedObject, {
          set: [
            {
              path,
              value: newValue,
            }
          ]
        });
      },

      /**
       * This method is called when a event for the link is received.
       **/
      onEvent(ev) {
        // Get value from event
        const path = ev.payload.path
        const processUuid = ev.processUuid
        const ident = `${processUuid}:${path}`
		
        if (this.constantLinkObject) {
          if (this.constantLinkObject.ident === ident) {
            this.constantValue = ev.payload.value;
          }
        }

        if (this.labelLinkObject) {
          if (this.labelLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.label = ev.payload.value;
          }
        }

        if (this.submitLabelLinkObject) {
          if (this.submitLabelLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.submitLabel = ev.payload.value;
          }
        }
        
		if (this.ident == ident) {
			const evValue = this.panel.getEventValue(ev)
			const formType = this.getFormType();
			if (this.eventValue !== evValue) {
				this.eventValue = evValue;
			}
			if (this.type !== formType) {
			  this.type = formType
			}
		}
      },

      getFormType() {
        if (this.object && this.object.customData && this.object.customData.setValueData && this.object.customData.setValueData.attrs) {
          if (this.object.customData.setValueData.attrs.type) {
            return this.object.customData.setValueData.attrs.type;
          }
        }
        switch (typeof this.eventValue) {
          case 'string':
            return 'text';
          case 'number':
            return 'number';
          case 'boolean':
            return 'toggle';
        }

        return 'text';
      }
    },

    // Define elements within the ui configuration...
    nodes() {
      if (!this.linked) {
        return [{
          type: 'NgBanner',
          props: {
            text: 'notLinked',
            color: 'warning',
            textColor: 'white',
            icon: 'warning',
            iconColor: 'white',
          },
        }]
      }
      
      return [
        // any ui component node can be used...
        {
          type: this.type === 'constant' ? 'div' : 'NgForm',
          props: {
            column: true,
            onSubmit: () => this.onPublish(this.eventValue),
            submitLabel: this.object.customData.setValueData.attrs.submitLabel ? this.object.customData.setValueData.attrs.submitLabel : 'setValue',
          },
          children: {
            default: () => {
              return [
                // child nodes or string content
                {
                  type: this.type === 'constant' ? 'NgActionButton' : 'NgFormInput',
                  props: {
                    ...this.object.customData.setValueData.attrs,
                    trueValue: this.object.customData.setValueData.attrs.constantTrueValue,
                    falseValue: this.object.customData.setValueData.attrs.constantFalseValue,
                    type: this.type,
                    hold: this.hold,
                    holdTimeout: 100,
                    modelValue: this.eventValue,
                    fullWidth: true,
                    'onUpdate:modelValue': (val) => {
                      this.eventValue = val
                      if (['toggle', 'checkbox'].includes(this.type)) {
                        this.onPublish(this.eventValue)
                      }
                    },
                    'onHold:stop': () => {
                      // impulse activate
                      if (this.holdClick) {
                        this.holdClick = false;
                        this.onPublish(false);
                      }
                    },
                    'onHold:start': () => {
                      // impulse deactivate
                      if (!this.holdClick) {
                        this.holdClick = true;
                        this.onPublish(true);
                      }
                    },
                    'onBlur': () => {
                      if (this.type !== 'constant') {
                        this.onPublish(this.eventValue);
                      }
                    },
                    'onClick': () => {
                      if (this.type === 'constant' && this.hold === false) {
                        switch (this.setType) {
                          case 'set':
                            this.onPublish(true);
                            break;
                          case 'reset':
                            this.onPublish(false);
                            break;
                          case 'toggle':
                            this.onPublish(!this.eventValue);
                            break;
                          default:
                            this.onPublish(this.constantValue);
                        }
                      }
                    },
                  },
                },
              ]
            }
          },
        },
      ]
    },
  }
})